From 4facb8db9130d6d02a5275c450ca94703b8356bd Mon Sep 17 00:00:00 2001
From: Merlijn Wajer <merlijn@wizzup.org>
Date: Sun, 17 May 2020 19:30:14 +0200
Subject: [PATCH 2/2] HACK: korad-kaxxxxp: STATUS returns more data, and hack
 around extra 0a char

---
 src/hardware/korad-kaxxxxp/protocol.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

diff --git a/src/hardware/korad-kaxxxxp/protocol.c b/src/hardware/korad-kaxxxxp/protocol.c
index bbcd2990..41277214 100644
--- a/src/hardware/korad-kaxxxxp/protocol.c
+++ b/src/hardware/korad-kaxxxxp/protocol.c
@@ -31,7 +31,7 @@ SR_PRIV int korad_kaxxxxp_send_cmd(struct sr_serial_dev_inst *serial,
 
 	char* newcmd = g_strconcat(cmd, "\\n", NULL);
 
-	sr_dbg("Sending '%s'.", cmd);
+	sr_dbg("Sending '%s'.", newcmd);
 	if ((ret = serial_write_blocking(serial, newcmd, strlen(newcmd), 0)) < 0) {
 		sr_err("Error sending command: %d.", ret);
 		free(newcmd);
@@ -178,7 +178,7 @@ SR_PRIV int korad_kaxxxxp_get_value(struct sr_serial_dev_inst *serial,
 				int target, struct dev_context *devc)
 {
 	int ret, count;
-	char reply[6];
+	char reply[7];
 	float *value;
 	char status_byte;
 	gboolean prev_status;
@@ -187,7 +187,7 @@ SR_PRIV int korad_kaxxxxp_get_value(struct sr_serial_dev_inst *serial,
 	give_device_time_to_process(devc);
 
 	value = NULL;
-	count = 5;
+	count = 6;
 
 	switch (target) {
 	case KAXXXXP_CURRENT:
@@ -216,7 +216,7 @@ SR_PRIV int korad_kaxxxxp_get_value(struct sr_serial_dev_inst *serial,
 	case KAXXXXP_OVP:
 		/* Read status from device. */
 		ret = korad_kaxxxxp_send_cmd(serial, "STATUS?");
-		count = 1;
+		count = 4;
 		break;
 	default:
 		sr_err("Don't know how to query %d.", target);
-- 
2.24.1

